//////////////////////////////////////////////////////
//  Importer
//////////////////////////////////////////////////////

import java.awt.*;

//////////////////////////////////////////////////////
//  Klass Playfield
//////////////////////////////////////////////////////

/** Ett Tetris-spelflt. */
public class Playfield
{
    private int f[];
    private int w;
    private int h;
    
    /** Skapar ett Tetris-spelflt av given storlek,
	med random niver av slumpade ldor. */
    public Playfield(int width, int height, int random)
    {
	w=width;
	h=height;
	f=new int[w*h];
	if(random<0) random=0;
	if(random>5) random=5;
	int l=random*2, i;
	for(i=0;i<w*(h-l);i++)
	    f[i]=-1;
	for(;i<w*h;i++)
	    {
		if(Math.random()<.5)
		    f[i]=-1;
		else
		    f[i]=(int)(Math.random()*7.0);
	    }
    }
    
    /** Tar bort fyllda rader och returnerar antalet rader som togs bort. */
    int checkLines()
    {
	int l=0;
	
	for(int j=0;j<h;j++)
	    {
		int n=0;
		for(int i=0;i<w;i++)
		    if(get(i, j)>=0)
			n++;
		if(n==w)
		    {
			removeLine(j);
			l++;
		    }
	    }
	return l;
    }	
    
    /** Tar bort en rad. */
    private void removeLine(int n)
    {
	for(int i=n*w+(w-1);i>=w;i--)
	    f[i]=f[i-w];
	for(int i=0;i<w;i++)
	    f[i]=-1;
    }
    
    /** Returnerar ldnumret p den aktuella platsen */
    public int get(int x, int y)
    {
	if(x<0 || x>=w || y>=h)
	    return 10; // Drifrn kan du inte hmta!
	if(y<0)
	    return -1; // Ovanfr spelfltet r det alltid "tomt"
	return f[x+y*w];
    }
    
    /** Stter ut ldan p den aktuella platsen. */
    public void put(int b, int x, int y)
    {
	if(x<0 || x>=w || y<0 || y>=h)
	    return;
	f[x+y*w]=b;
    }
    
    /** Returnerar bredden p spelfltet. */
    public int getWidth()
    {
	return w;
    }
    
    /** Returnerar hjden p spelfltet. */
    public int getHeight()
    {
	return h;
    }
}
